Package org.apache.sis.referencing.datum

## Class DefaultTemporalDatum

- Object
- - FormattableObject
  - - AbstractIdentifiedObject
    - - AbstractDatum
      - - DefaultTemporalDatum

- All Implemented Interfaces:
    `Serializable`, `Deprecable`, `LenientComparable`, `Datum`, `TemporalDatum`, `IdentifiedObject`

      public class DefaultTemporalDatum
      extends AbstractDatum
      implements TemporalDatum

  Defines the origin of a temporal coordinate reference system.
  Creating new temporal datum instances
  New instances can be created either directly by specifying all information to a factory method (choices 3 and 4 below), or indirectly by specifying the identifier of an entry in a database (choices 1 and 2 below). Choice 1 in the following list is the easiest but most restrictive way to get a temporal datum. The other choices provide more freedom.
  1. Create a `TemporalDatum` from one of the static convenience shortcuts listed in `CommonCRS​.Temporal​.datum()`.
  2. Create a `TemporalDatum` from an identifier in a database by invoking `DatumAuthorityFactory​.createTemporalDatum(String)`.
  3. Create a `TemporalDatum` by invoking the `DatumFactory​.createTemporalDatum(…)` method, (implemented for example by `GeodeticObjectFactory`).
  4. Create a `DefaultTemporalDatum` by invoking the constructor.
  Example: the following code gets a temporal datum having its origin at January 1st, 4713 BC at 12:00 UTC:

  >     TemporalDatum datum = CommonCRS.Temporal.JULIAN.datum();

  Immutability and thread safety
  This class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.
  Since:
    0.4
  See Also:
    `CommonCRS​.Temporal​.datum()`, `DefaultTimeCS`, `DefaultTemporalCRS`, `GeodeticAuthorityFactory​.createTemporalDatum(String)`, Serialized Form

  Defined in the `sis-referencing` module

- - ### Field Summary

    - ### Fields inherited from class AbstractIdentifiedObject

      `DEPRECATED_KEY, LOCALE_KEY`

    - ### Fields inherited from interface Datum

      `ANCHOR_POINT_KEY, DOMAIN_OF_VALIDITY_KEY, REALIZATION_EPOCH_KEY, SCOPE_KEY`

    - ### Fields inherited from interface IdentifiedObject

      `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `` | `DefaultTemporalDatum​(Map<String,​?> properties, Date origin)` | Creates a temporal datum from the given properties.
    `protected` | `DefaultTemporalDatum​(TemporalDatum datum)` | Creates a new datum with the same values than the specified one.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultTemporalDatum` | `castOrCopy​(TemporalDatum object)` | Returns a SIS datum implementation with the same values than the given arbitrary implementation.
    `protected long` | `computeHashCode()` | Invoked by `hashCode()` for computing the hash code when first needed.
    `boolean` | `equals​(Object object, ComparisonMode mode)` | Compares this temporal datum with the specified object for equality.
    `protected String` | `formatTo​(Formatter formatter)` | Formats this datum as a Well Known Text `TimeDatum[…]` element.
    `Class<? extends TemporalDatum>` | `getInterface()` | Returns the GeoAPI interface implemented by this class.
    `Date` | `getOrigin()` | Returns the date and time origin of this temporal datum.

    - ### Methods inherited from class AbstractDatum

      `castOrCopy, getAnchorPoint, getDomainOfValidity, getRealizationEpoch, getScope, isHeuristicMatchForName`

    - ### Methods inherited from class AbstractIdentifiedObject

      `castOrCopy, equals, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated`

    - ### Methods inherited from class FormattableObject

      `print, toString, toString, toWKT`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface Datum

      `getDomainOfValidity, getScope`

    - ### Methods inherited from interface IdentifiedObject

      `getAlias, getIdentifiers, getName, getRemarks, toWKT`

    - ### Methods inherited from interface TemporalDatum

      `getAnchorPoint, getRealizationEpoch`

- - ### Constructor Detail

    - #### DefaultTemporalDatum

          public DefaultTemporalDatum​(Map<String,​?> properties,
                                      Date origin)

      Creates a temporal datum from the given properties. The properties map is given unchanged to the super-class constructor. The following table is a reminder of main (not all) properties:

      Recognized properties (non exhaustive list)
      Property name | Value type | Returned by
      --- | --- | ---
      "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
      "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
      "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
      "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`
      "anchorPoint" | `InternationalString` or `String` | `AbstractDatum.getAnchorPoint()`
      "realizationEpoch" | `Date` | `AbstractDatum.getRealizationEpoch()`
      "domainOfValidity" | `Extent` | `AbstractDatum.getDomainOfValidity()`
      "scope" | `InternationalString` or `String` | `AbstractDatum.getScope()`

      Parameters:
        `properties` - the properties to be given to the identified object.
        `origin` - the date and time origin of this temporal datum.
      See Also:
        `GeodeticObjectFactory​.createTemporalDatum(Map, Date)`

    - #### DefaultTemporalDatum

          protected DefaultTemporalDatum​(TemporalDatum datum)

      Creates a new datum with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

      This constructor performs a shallow copy, i.e. the properties are not cloned.

      Parameters:
        `datum` - the datum to copy.
      See Also:
        `castOrCopy(TemporalDatum)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultTemporalDatum castOrCopy​(TemporalDatum object)

      Returns a SIS datum implementation with the same values than the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getInterface

          public Class<? extends TemporalDatum> getInterface()

      Returns the GeoAPI interface implemented by this class. The SIS implementation returns `TemporalDatum​.class`.
      Note for implementers: Subclasses usually do not need to override this method since GeoAPI does not define `TemporalDatum` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
      Overrides:
        `getInterface` in class `AbstractDatum`
      Returns:
        `TemporalDatum​.class` or a user-defined sub-interface.

    - #### getOrigin

          public Date getOrigin()

      Returns the date and time origin of this temporal datum.
      Specified by:
        `getOrigin` in interface `TemporalDatum`
      Returns:
        the date and time origin of this temporal datum.

    - #### equals

          public boolean equals​(Object object,
                                ComparisonMode mode)

      Compares this temporal datum with the specified object for equality.
      Specified by:
        `equals` in interface `LenientComparable`
      Overrides:
        `equals` in class `AbstractDatum`
      Parameters:
        `object` - the object to compare to `this`.
        `mode` - `STRICT` for performing a strict comparison, or `IGNORE_METADATA` for comparing only properties relevant to coordinate transformations.
      Returns:
        `true` if both objects are equal.
      See Also:
        `AbstractIdentifiedObject​.computeHashCode()`, `Utilities​.deepEquals(Object, Object, ComparisonMode)`

    - #### computeHashCode

          protected long computeHashCode()

      Invoked by `hashCode()` for computing the hash code when first needed. See `AbstractIdentifiedObject​.computeHashCode()` for more information.
      Overrides:
        `computeHashCode` in class `AbstractDatum`
      Returns:
        the hash code value. This value may change in any future Apache SIS version.

    - #### formatTo

          protected String formatTo​(Formatter formatter)

      Formats this datum as a Well Known Text `TimeDatum[…]` element.
      Compatibility note: `TimeDatum` is defined in the WKT 2 specification only.
      Overrides:
        `formatTo` in class `AbstractDatum`
      Parameters:
        `formatter` - the formatter where to format the inner content of this WKT element.
      Returns:
        `"TimeDatum"`.
      See Also:
        WKT 2 specification §14.2